void DrawText(int i)
{
  textSize(TEXTSIZE);
  fill(255, 255, 255);
  float adjustedRadius = (radius + 50)/2;
  if(i + 2006 >= 2008 && i + 2006 <= 2013)
    adjustedRadius += 2 * TEXTSIZE;
  if(i + 2006 == 2010 || i + 2006 == 2013 || i + 2006 == 2016)
    fill(255, 0, 0);
  text(i + 2006, centerX + adjustedRadius * cos(PI/12 + i * PI / 6), centerY + adjustedRadius * sin(PI/12 + i * PI / 6));
}

void DrawNote()
{
  textSize(TEXTSIZE);
  fill(255, 255, 255);
  String s = "Quentin Tarantino";
  text(s, centerX - TEXTSIZE * s.length() / 4, centerY + 5);
  String[] movieNames = {"Reservoir Dogs (1992)", "Pulp Fiction (1994)", "Jackie Brown (1997)", "Kill Bill: Volume 1 (2003)", "Kill Bill: Volume 2 (2004)", 
                        "Death Proof (2007)", "Inglourious Basterds (2009)", "Django Unchained (2012)", "The Hateful Eight (2015)"};
  boolean[] find = {false, false, false, false, false, false, false, false, false};                   
  for(int j = 0; j < checkoutsYearly.getRowCount(); j++)
  {
    int i = FindMovieIndex(j) - 1;
    println("i = " + i + " movie:" + movieNames[i]);

    if(find[i] == false)
    {
      find[i] = true;
      text(movieNames[i], WIDTH - 2 * TEXTSIZE * movieNames.length, HEIGHT - (10 - i) * TEXTSIZE);
      strokeWeight(6);
      SwitchFillColor(i + 1);
      point(WIDTH - 2.1 * TEXTSIZE * movieNames.length, HEIGHT - (10 - i) * TEXTSIZE - 4 );
    }
    
  }
  s = "Quentin's Films";
  textSize(TEXTSIZE * 1.5);
  text(s, WIDTH - 1.4 * TEXTSIZE  * s.length() , HEIGHT - 14 * TEXTSIZE );
  s =  "and His Oscar Years";
  text(s, WIDTH - TEXTSIZE  * s.length() , HEIGHT - 12 * TEXTSIZE);
}

void DrawScanner()
{
  // Linear Gradient Arc
  float startArc = 0.0, endArc = 0.0;
  float deltaArc = frameCount * scannerSpeed % TWO_PI;
  // println("deltaArc:", deltaArc);
  for(int i = 0;i < 90; i++)
  {
    stroke(#e6e6e6, 0);
    fill(#e6e6e6, i/8);
    if(frameCount == 1)
    {
      startArc = i * HALF_PI/ 3 /90;
      endArc = HALF_PI / 3;
    }  
    else
    {
      startArc = i * HALF_PI/ 3 /90 + deltaArc;
      endArc = HALF_PI / 3 + deltaArc;
    }
    if(i == 0)
      currStartArc = startArc;
    arc(centerX, centerY, radius + 50, radius + 50, startArc, endArc);
    // println("end", endArc);
    
  }
  currEndArc = currStartArc + PI / 6;
  //println("frameCount:", frameCount, " startArc:", currStartArc," endArc:" , currEndArc);
  
}

void loadAllData()
{
  boolean ifRand = false;
  int startIndex = FindIndex(currStartArc);
  int endIndex = FindIndex(currEndArc);
  
  for(int i = 0; i < YEARS; i++)
  {
    for(int j = 0; j < checkoutsYearly.getRowCount(); j++)
    {
      int size = checkouts.get(j).third[i];
      float currentRadius = (radius / 2) / 9 * FindMovieIndex(j);
      float angle = random(PI/6 * i, (PI/6) * (i + 1));
      float x = centerX + currentRadius * cos(angle);
      float y = centerY + currentRadius * sin(angle);
      allPoints.add(new float[]{x, y, size,angle,j});
    }
  }
}
void GeneratePoints()
{
  for(int i = 0; i < checkoutsYearly.getRowCount(); i++)
  {
     float currentRadius = (radius / 2) / 9 * FindMovieIndex(i);
     float angle = random(currStartArc, currEndArc);
     float x = centerX + currentRadius * cos(angle);
     float y = centerY + currentRadius * sin(angle);
     points[i][0] = x;
     points[i][1] = y;
     lifetime = LIFETIME;
   }
}

void GeneratePoints2()
{
  for(int i = 0; i < checkoutsYearly.getRowCount(); i++)
  {
     float currentRadius = (radius / 2) / 9 * FindMovieIndex(i);
     float angle = random(currStartArc, currEndArc+PI/6.0f);
     float x = centerX + currentRadius * cos(angle);
     float y = centerY + currentRadius * sin(angle);
     points[i][0] = x;
     points[i][1] = y;
     points[i][2] = angle-PI/6.0f;
     //lifetime = LIFETIME;
     
   }
}

void SwitchStrokeColor(String s)
{
  switch(s)
  {
    case "acdvd": stroke(139, 213, 224, 100); break;
    case "accd": stroke(238, 58, 67, 100); break;
    case "acbk": stroke(255, 255, 79, 100); break;
    case "acvhs": stroke(122, 192, 67, 100); break;
  }
}

void SwitchFillColor(int n, int i)
{
  switch(n)
  {
    // #125C2D,#276C3A,#3C7D47,#518D56,#699D67,#82AD78,#9CBD8A,#B8CC9E,#D7DBB2,#F6E9C8
    //case 1: stroke(#80dfff, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 2: stroke(#cc6699, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 3: stroke(#BC2B33, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 4: stroke(#DB9070, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 5: stroke(#FCDD55, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 6: stroke(#5FC9B9, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 7: stroke(#ffffff, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 8: stroke(#8cd98c, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    //case 9: stroke(#DF8A3B, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    
    case 1: stroke(#928B8B, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 2: stroke(#A3DE83, 255*cos(currEndArc-allPoints.get(i)[3])); break; 
    case 3: stroke(#EF2531, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 4: stroke(#FCEC2C, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 5: stroke(#1F9BD7, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 6: stroke(#8FECC8, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 7: stroke(#ffffff, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 8: stroke(#F78F1E, 255*cos(currEndArc-allPoints.get(i)[3])); break;
    case 9: stroke(#33B0B2, 255*cos(currEndArc-allPoints.get(i)[3])); break;
  }
}

void SwitchFillColor(int n)
{
  switch(n)
  {
    // #125C2D,#276C3A,#3C7D47,#518D56,#699D67,#82AD78,#9CBD8A,#B8CC9E,#D7DBB2,#F6E9C8
    case 1: stroke(#928B8B, 255); break;
    case 2: stroke(#A3DE83, 255); break;
    case 3: stroke(#EF2531, 255); break;
    case 4: stroke(#FCEC2C, 255); break;
    case 5: stroke(#1F9BD7, 255); break;
    case 6: stroke(#8FECC8, 255); break;
    case 7: stroke(#ffffff, 255); break;
    case 8: stroke(#F78F1E, 255); break;
    case 9: stroke(#33B0B2, 255); break;
  }
}

int FindMovieIndex(int i)
{
  int index = 0;
  // find movie's index
  if(i == 0 || i == 1 || i == 23)
    index = 6;
  else if(i == 2 || i == 3 || i == 4)
    index = 8;
  else if(i == 5 || i == 6)
    index = 9;
  else if(i == 7)
    index = 7;
  else if(i == 8 || i == 9 || i == 10 || i == 11)
    index = 3;
  else if(i == 12 || i == 13 || i == 16)
    index = 4;
  else if(i == 14 || i == 15)
    index = 5;
  else if(i == 17 || i == 18 || i == 19 || i == 20 || i == 21 || i == 22)
    index = 2;
  else if(i == 24 || i == 25 || i == 26)
    index = 1;    
  return index;
}

int FindIndex(float arc)
{
  int currentIndex = 0;
  for(int i = 0; i < YEARS; i++)
  {
    if(arc >= i * PI / 6 && arc <= (i + 1) * PI / 6)
    {
      currentIndex = i;
      break;
    }  
  }
  //println("currentYear", currentIndex);
  return currentIndex;
}